#!/usr/bin/env python
import marshal
from os.path import *
from assert_exists import *
from extension import *
from public import *

# # http://nedbatchelder.com/blog/200804/the_structure_of_pyc_files.html

def code(path):
    """return marshal.load(file)"""
    if exists(path):
        h = open(path, "rb")
        return marshal.load(h)

@public
def ispythoncompiled(path):
    """return True if file compiled"""
    if not path: return False
    if extension(path)=="py": return False
    if path[-1]!="c": return False
    if extension(path)=="pyc": return True
    assert_exists(path)
    try:
        code(path)
        return True
    except:
        return False

if __name__=="__main__":
    print(ispythoncompiled("file.pyc")) # True
    print(ispythoncompiled("file.py")) # False
    print(ispythoncompiled(None)) # False
    print(ispythoncompiled(None)) # False
    
